### Virtual Method

# FwupdPlugin Firmware tokenize

since: 2.0.0

#### Declaration [src]

    gboolean
    tokenize (
      FuFirmware* self,
      GInputStream* stream,
      guint64 flags,
      GError** error
    )

#### Description [src]

Tokenizes a firmware, typically breaking the firmware into records.

Records can be enumerated using subclass-specific functionality, for example using fu_srec_firmware_get_records().

Available since: 2.0.0

#### Parameters

`stream`

  Type: `GInputStream`

  A `GInputStream`.

  The data is owned by the caller of the method.

`flags`

  Type: `guint64`

  `FuFirmwareParseFlags`, e.g. `FWUPD_INSTALL_FLAG_FORCE`.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the virtual function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` for success.